# coding: utf-8


"""
IGNORE:
    Nutanix Security APIs

    Manage security features, such as encryption, certificates, or platform hardening.  # noqa: E501

    OpenAPI spec version: 4.0.1-beta-1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_security_py_client.models.security.v4.common.ClusterProjection import ClusterProjection  # noqa: F401,E501
from ntnx_security_py_client.models.security.v4.common.Timescale import Timescale  # noqa: F401,E501
from ntnx_security_py_client.models.security.v4.report.IssueSummary import IssueSummary  # noqa: F401,E501
from ntnx_security_py_client.models.security.v4.report.Summary import Summary  # noqa: F401,E501

class SummaryProjection(Summary):

    """

    :param cluster_projection: (:attr:`cluster_projection`) 
    :type cluster_projection: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'cluster_projection': 'security.v4.common.ClusterProjection',
        'cluster_ext_id': 'str',
        'security_hardening_summary': 'security.v4.report.IssueSummary',
        'stig_summary': 'security.v4.report.IssueSummary',
        'vulnerabilities_summary': 'security.v4.report.IssueSummary',
        'password_summary': 'security.v4.report.IssueSummary',
        'trend_type': 'security.v4.common.Timescale',
        'last_refresh_time': 'datetime',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'cluster_projection': 'clusterProjection',
        'cluster_ext_id': 'clusterExtId',
        'security_hardening_summary': 'securityHardeningSummary',
        'stig_summary': 'stigSummary',
        'vulnerabilities_summary': 'vulnerabilitiesSummary',
        'password_summary': 'passwordSummary',
        'trend_type': 'trendType',
        'last_refresh_time': 'lastRefreshTime',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, cluster_projection=None, cluster_ext_id=None, security_hardening_summary=None, stig_summary=None, vulnerabilities_summary=None, password_summary=None, trend_type=None, last_refresh_time=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        Summary.__init__(self, cluster_ext_id, security_hardening_summary, stig_summary, vulnerabilities_summary, password_summary, trend_type, last_refresh_time, ext_id, links, tenant_id, *args, **kwargs)
        self.__cluster_projection = None
        self.discriminator = None
        if cluster_projection is not None:
            self.__cluster_projection = cluster_projection

    def _initialize_object_type(self):
        return 'security.v4.report.SummaryProjection'

    def _initialize_object_version(self):
        return 'v4.r0.b1'


    @property
    def cluster_projection(self):
        """
        

        :type:
            :class:`~ntnx_security_py_client.models.security.v4.common.ClusterProjection`
        """  # noqa: E501
        return self.__cluster_projection

    @cluster_projection.setter
    def cluster_projection(self, cluster_projection):

        self.__cluster_projection = cluster_projection

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(SummaryProjection, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SummaryProjection):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

